# By Marco Costantini
Sudoku := function (matrix)
local parameter, parameter2,i, ii, matrix_bak, clean, positions, iii, iiii, temp, res;

#parameter2:= DimensionsMat(matrix)[1];
#if parameter2 <> DimensionsMat(matrix)[2] then Error ("different dimensions");fi;
parameter2:=Length(matrix);

parameter := Sqrt(parameter2);

for i in [1..parameter2] do
for ii in [1..parameter2] do
if not IsBound(matrix[i][ii]) then 
matrix[i][ii] := [1..parameter2];
fi;
od;
od;


clean := function ( subset )
    local  i, ii;
    for i  in [ 1 .. parameter2 ]  do

        if IsInt( subset[i] )  then
            for ii  in [ 1 .. parameter2 ]  do
                if IsList( subset[ii] ) and subset[i] in subset[ii]  then
                    Unbind( subset[ii][Position( subset[ii], subset[i] )] );
                    subset[ii] := SortedList( subset[ii] );
                    if Length( subset[ii] ) = 1  then
                        subset[ii] := subset[ii][1];
                    fi;
                fi;
            od;

        elif IsList( subset[i] )  then
            for ii  in [ 1 .. Length( subset[i] ) ]  do
                if ForAll( Union( [ 1 .. i - 1 ], [ i + 1 .. parameter2 ] ), 
x-> (IsList(subset[x]) and not subset[i][ii] in subset[x]) or 
IsInt(subset[x]) and subset[i][ii] <> subset[x])  then
                    subset[i] := subset[i][ii];
                    break;
                fi;
            od;

        fi;
    od;
    return StructuralCopy( subset );
end;

matrix_bak:=fail;

repeat

#Print("#\c");
matrix_bak := StructuralCopy(matrix);


#Print(matrix, "\n");

# orizontali

for i in [ 1 .. parameter2 ]  do
clean(matrix[i]);
od;

#Print(matrix, "\n");

# verticali

for i in [ 1 .. parameter2 ]  do
temp := StructuralCopy(List ( [ 1 .. parameter2 ], x -> matrix[x][i] ));
temp := clean(temp);
#if res<>temp then
for ii in [ 1 .. parameter2 ]  do
matrix[ii][i] := temp[ii];
od;
#fi;
od;


#Print(matrix, "\n");
# quadratini


for iii in [ 0 .. parameter-1 ]  do
for iiii in [ 0 .. parameter-1 ]  do

temp:=[];
for i in [ 1 .. parameter ]  do
Append (temp, StructuralCopy(matrix[iii*parameter+i]{[iiii*parameter+1..(iiii+1)*parameter]}));
od;

temp := clean(temp);
#if res<>temp then
for i in [ 1 .. parameter ]  do
matrix[iii*parameter+i]{[iiii*parameter+1..(iiii+1)*parameter]} := 
temp{[(i-1)*parameter+1..i*parameter]};
od;
#fi;

od;
od;

#Print(matrix, "\n");


until matrix_bak = matrix;

#Print("\n");
return matrix;

end;
